//+------------------------------------------------------------------+
//| Tral v bezubitke.mq4 |
//|  
//|  
//+------------------------------------------------------------------+
#property copyright "RomanKutemov"


extern double Price_TP           =1.9985; // ,      .
extern int    TrailStop          =15;
extern int    TrailStep          =55;
int STP, SPR;

//+------------------------------------------------------------------+
//| script "orders treling v bezubitke"     |
//+------------------------------------------------------------------+
int start()
  {
   int i;
   STP=MarketInfo(Symbol(),MODE_STOPLEVEL);
   SPR=MarketInfo(Symbol(),MODE_SPREAD);
   Price_TP=NormalizeDouble(Price_TP,Digits);
Comment("   "+Price_TP);
//     
if ( OrdersTotal() > 0 )
{
// for( i=0; i<OrdersTotal(); i++ )
for( i=OrdersTotal(); i>0; )
{
i--;
if ( OrderSelect(i,SELECT_BY_POS) )
{
if ( OrderSymbol() != Symbol())
continue;
else if ( OrderType() == OP_BUY && Bid>Price_TP)
         {
            if(TrailStop>=STP && TrailStop>0)
            {
               if(Bid-Price_TP>TrailStop*Point && NormalizeDouble(OrderStopLoss(),Digits)<NormalizeDouble(Price_TP,Digits))
                  OrderModify(OrderTicket(),OrderOpenPrice(),Price_TP,OrderTakeProfit(),0,CLR_NONE);
               else if(Bid-Price_TP>TrailStop*Point &&
               NormalizeDouble(OrderStopLoss(),Digits)<NormalizeDouble(Bid-(TrailStop+TrailStep)*Point,Digits)
               && OrderStopLoss()>=Price_TP)
                  OrderModify(OrderTicket(),OrderOpenPrice(),NormalizeDouble(Bid-TrailStop*Point,Digits),OrderTakeProfit(),0,CLR_NONE);
            }
         }  
else if ( OrderType() == OP_SELL && Bid<Price_TP)
         {
            if(TrailStop>=STP && TrailStop>0)
            {
               if(Price_TP-Ask>TrailStop*Point &&
               (NormalizeDouble(OrderStopLoss(),Digits)>NormalizeDouble(Price_TP,Digits) || OrderStopLoss()==0))
                  OrderModify(OrderTicket(),OrderOpenPrice(),Price_TP,OrderTakeProfit(),0,CLR_NONE);
               else if(Price_TP-Ask>TrailStop*Point &&
               NormalizeDouble(OrderStopLoss(),Digits)>NormalizeDouble(Ask+(TrailStop+TrailStep)*Point,Digits)
               && NormalizeDouble(OrderStopLoss(),Digits)<=NormalizeDouble(Price_TP,Digits))
                  OrderModify(OrderTicket(),OrderOpenPrice(),NormalizeDouble(Ask+TrailStop*Point,Digits),OrderTakeProfit(),0,CLR_NONE);
            }
         }
}
}
}
//----
   return(0);
  }

